/*
kalman_filtern.hh

This C++ header file defines the NML Messages used for command and status by KALMAN_FILTER_MODULE
Template Version 1.1

MODIFICATIONS:
Mon Dec 18 15:46:17 EST 2000	Created by rcsdesign.

*/

// Prevent Multiple Inclusion
#ifndef KALMAN_FILTERN_HH
#define KALMAN_FILTERN_HH

// Include Files
#include "rcs.hh" 	// Common RCS definitions

// Predefined type files
// RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

// RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.
#define NUM_OF_STATES 2
#define NUM_OF_INPUTS 1
#define NUM_OF_OUTPUTS 1


// Define the integer type ids.
//  RCS-Design-MERGE-DISABLE Edits to the following area will NOT be preserved by the RCS-Design tool.

#define KALMAN_FILTER_STATUS_TYPE 1000
#define KALMAN_FILTER_HALT_TYPE 1001
#define KALMAN_FILTER_INIT_TYPE 1002
#define KALMAN_FILTER_RUN_TYPE 1003
#define KALMAN_FILTER_SET_COVARIANCE_TYPE 1004
#define KALMAN_FILTER_SET_NOISE_COVARIANCE_TYPE 1005
#define KALMAN_FILTER_SET_OUT_NOISE_AUTOCOV_TYPE 1006
#define KALMAN_FILTER_SET_STATE_TYPE 1007
#define KALMAN_FILTER_SET_SYS_MATRIX_A_TYPE 1008
#define KALMAN_FILTER_SET_SYS_MATRIX_B_TYPE 1009
#define KALMAN_FILTER_SET_SYS_MATRIX_C_TYPE 1010
#define KALMAN_FILTER_SET_SYS_NOISE_AUTOCOV_TYPE 1011
//  RCS-Design-MERGE-ENABLE Edits after this line will be preserved by the RCS-Design tool.


// Define the NML Message Classes

// Status Class
class KALMAN_FILTER_STATUS : public RCS_STAT_MSG
{
public:

	// Normal Constructor
	KALMAN_FILTER_STATUS();

	// Constructor used by derived classes
	KALMAN_FILTER_STATUS(NMLTYPE t, size_t s) :  RCS_STAT_MSG(t,s) {};

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double state_estimates[NUM_OF_STATES];
  
};

// Command Classes

class KALMAN_FILTER_HALT : public RCS_CMD_MSG
{
public:

	//Constructor
	KALMAN_FILTER_HALT();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

};

class KALMAN_FILTER_INIT : public RCS_CMD_MSG
{
public:

	//Constructor
	KALMAN_FILTER_INIT();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

};

class KALMAN_FILTER_RUN : public RCS_CMD_MSG
{
public:

	//Constructor
	KALMAN_FILTER_RUN();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.

};

class KALMAN_FILTER_SET_COVARIANCE : public RCS_CMD_MSG
{
public:

	//Constructor
	KALMAN_FILTER_SET_COVARIANCE();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double diag_value;
};

class KALMAN_FILTER_SET_NOISE_COVARIANCE : public RCS_CMD_MSG
{
public:

	//Constructor
	KALMAN_FILTER_SET_NOISE_COVARIANCE();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double covariance_elements[NUM_OF_OUTPUTS * NUM_OF_STATES];

};

class KALMAN_FILTER_SET_OUT_NOISE_AUTOCOV : public RCS_CMD_MSG
{
public:

	//Constructor
	KALMAN_FILTER_SET_OUT_NOISE_AUTOCOV();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double diag_value;
};

class KALMAN_FILTER_SET_STATE : public RCS_CMD_MSG
{
public:

	//Constructor
	KALMAN_FILTER_SET_STATE();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double state_to_set[NUM_OF_STATES];
};

class KALMAN_FILTER_SET_SYS_MATRIX_A : public RCS_CMD_MSG
{
public:

	//Constructor
	KALMAN_FILTER_SET_SYS_MATRIX_A();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double matrix_A_elements[NUM_OF_STATES * NUM_OF_STATES];
};

class KALMAN_FILTER_SET_SYS_MATRIX_B : public RCS_CMD_MSG
{
public:

	//Constructor
	KALMAN_FILTER_SET_SYS_MATRIX_B();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double matrix_B_elements[NUM_OF_STATES * NUM_OF_INPUTS];

};

class KALMAN_FILTER_SET_SYS_MATRIX_C : public RCS_CMD_MSG
{
public:

	//Constructor
	KALMAN_FILTER_SET_SYS_MATRIX_C();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double matrix_C_elements[NUM_OF_OUTPUTS * NUM_OF_STATES];

};

class KALMAN_FILTER_SET_SYS_NOISE_AUTOCOV : public RCS_CMD_MSG
{
public:

	//Constructor
	KALMAN_FILTER_SET_SYS_NOISE_AUTOCOV();

	// CMS Update Function
	void update(CMS *);

	// Place custom variables here.
  double diag_value;

};

// Declare NML format function
extern int kalman_filterFormat(NMLTYPE, void *, CMS *);

#endif 	// KALMAN_FILTERN_HH
