/*
	k_fltr_modulemain.cc

	This file provides the C++ main function which
	creates and runs the following control modules:

		KALMAN_FILTER_MODULE

	MODIFICATIONS:
	Mon Dec 18 15:46:19 EST 2000	Created.

*/

// Include Files
#include <stdlib.h>	// exit()
#include <signal.h>	// SIGINT, signal()
#include "rcs.hh" 	// Common RCS definitions
#include "nml_mod.hh" 	// NML_MODULE definitions
#include "kalman_filter.hh"	// definition of KALMAN_FILTER_MODULE

// flag signifying main loop is to terminate
int k_fltr_module_done = 0;

//signal handler for ^C
extern "C" void k_fltr_module_quit(int sig);
void k_fltr_module_quit(int sig)
{
	k_fltr_module_done = 1;
}

// main loop, running 1 controller(s)
#ifdef VXWORKS
extern "C" int k_fltr_module_run();

int k_fltr_module_run()
#else
int main(int argc, char **argv)
#endif
{

	set_rcs_print_destination(RCS_PRINT_TO_STDOUT);

	RCS_TIMER *timer = new RCS_TIMER(0.1);
	KALMAN_FILTER_MODULE *kalman_filter = new KALMAN_FILTER_MODULE();

	// set the SIGINT handler
	signal(SIGINT, k_fltr_module_quit);

	// enter main loop
	while(!k_fltr_module_done)
	{
		kalman_filter->controller();

		timer->wait();
	}

	// Delete Modules
	delete kalman_filter;

	// Delete Timer
	delete timer;
}

